Subject: Re: [net-next PATCH v2 0/3] net: phy: as21xxx: toggle In Band feature support

From: "Russell King (Oracle)" <[email-masked]>
Date: Fri, 23 Jan 2026 12:16:45 +0000

[Please note: gmail.com has become unreliable for email delivery,
google has too much power to decide what is spam and what isn't, with
no route for appeal. please consider switching to a different email
provider.]

On Fri, Jan 23, 2026 at 01:00:28PM +0100, Christian Marangi wrote:
> This is a new variant of the previous submitted patch adding a similar
> feature.
> 
> Old Aeonsemi Firmware permitted only to enable or disable In Band
> support and it couldn't be disabled after (or there wasn't a
> way to detect the current state of it)
> 
> As suggested by Russell this was bad Implementation. Some talk
> with Aeonsemi permitted to release a new firmware with correct
> implementation.
> 
> This series adds support for this if new firmware (1.9.1+) is
> used. On the new firmware, 2 new IPC command are introduced
> to GET the current state of DPC RA (Rate Adaption) or SET it.
> (DPC RA is effectively In Band mode)
> 
> It was verified on the same scenario and can confirm it works
> as expected. (Airoha AN7581/AN7583 with and without In Band
> mode) (If PCS is set to In Band and PHY isn't then no
> connection, so it's easy to verify correct functionality of
> this)
> 
> The new firmware is currently submitted to linux-firmware
> awaiting it to be merged.
> 
> For old firmware to save on compatibility we still enable
> In Band by default (this is what the current driver do)
> 
> This was discovered to be needed in some scenario as is effectively
> the most compatible featureset.
> 
> On a BananaPi R4 Pro, one of the 2 AS21xxx PHY is connected to
> one of the Switch port and such switch supports only In Band when
> set to USXGMII (assuming the Switch expect an SFP module to be
> attached where in absence of i2c or MDIO line In Band is always
> required)

Coupling the PHY's rate adaption with inband support, but not setting
phydev->rate_matching anywhere in this driver seems wrong, and highly
suspicious. I'm not sure what to think given what you've said above,
it just seems completely wrong what has happened here.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!